#-*- coding:utf-8 -*-

import clr
import sys

clr.AddReferenceByPartialName("PresentationCore")
clr.AddReferenceByPartialName("PresentationFramework")
clr.AddReferenceByPartialName("WindowsBase")

from System import *
from System.IO import *
from System.Windows import *
from System.Windows.Controls import *
from System.Windows.Controls.Primitives import *
from System.Windows.Input import *
from System.Collections.ObjectModel import *
from System.Windows.Markup import XamlReader
from System.Windows.Media.Imaging import *
from System.Windows.Media.Effects import *
import inifile8
from xamls import *
from datas import *
from strs import *

class SeeMe(Window):
    """
        SeeMe MainWindow class
    """
    def __init__(self, sset):
        """
            Window.__init__(self) is No
            Constructor has been
        """
        # Memory FilePath
        self.path = Path.GetDirectoryName(Path.GetFullPath(__file__))
        # Menu
        menu = XamlReader.Parse(menu_str)
        menu.FindName("save").Click += self.on_save
        menu.FindName("quit").Click += self.on_quit
        DockPanel.SetDock(menu, Dock.Top)
        # ToolBar
        toolbar = XamlReader.Parse(toolbar_str)
        toolbar.FindName("btn2").Click += self.on_save
        toolbar.FindName("img1").Source = BitmapImage(Uri(self.path + "\\img\\i_new.png"))
        toolbar.FindName("img2").Source = BitmapImage(Uri(self.path + "\\img\\i_save.png"))
        toolbar.FindName("img3").Source = BitmapImage(Uri(self.path + "\\img\\i_up.png"))
        toolbar.FindName("img4").Source = BitmapImage(Uri(self.path + "\\img\\i_down.png"))
        toolbar.FindName("img5").Source = BitmapImage(Uri(self.path + "\\img\\i_del.png"))
        DockPanel.SetDock(toolbar, Dock.Top)
        # ObservableCollection
        self.engines = ObservableCollection[Engine]()
        self.Resources["engines"] = self.engines
        # ListView
        self.listview = XamlReader.Parse(listview_str)
        DockPanel.SetDock(self.listview, Dock.Top)
        self.listview.ItemsSource = self.engines
        # StatusBar
        statusbar = StatusBar()
        DockPanel.SetDock(statusbar, Dock.Bottom)
        self.statusbar_item = StatusBarItem()
        self.statusbar_item.Content = "Search.ini Version"
        statusbar.Items.Add(self.statusbar_item)
        # Read Custom search.ini
        ini_path = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\Opera\\Opera 10 beta\\search.ini";
        if (File.Exists(ini_path)):
            ini = inifile8.Inifile(ini_path)
            v = ini.read_int("Version", "File Version", 0)
            self.statusbar_item.Content = "Search.ini Version " + str(v)
            s = ""
            i = 0
            while 1:
                i += 1
                s = "Search Engine %i" % i
                if not ini.section_exists(s):
                    break
                en = Engine()
                en.name   = ini.read_str(s, "Name", "")
                en.key    = ini.read_str(s, "Key", "")
                en.url    = ini.read_str(s, "URL", "")
                en.delete = not ini.read_bool(s, "Deleted", False)
                en.query  = ini.read_str(s, "Query", "")
                en.post   = ini.read_bool(s, "Is post", False)
                en.endsep = ini.read_bool(s, "Has endseparator", False)
                en.encode = ini.read_str(s, "Encoding", "utf-8")
                en.type   = ini.read_int(s, "Search Type", 0)
                en.pos    = ini.read_int(s, "Position", -1)
                en.nameid = ini.read_int(s, "Nameid", 0)
                en.verb   = ini.read_int(s, "Verbtext", 0)
                en.icon   = ini.read_str(s, "ICON", "")
                en.unique = ini.read_str(s, "UNIQUEID", "")
                self.engines.Add(en)
        # DockPanel
        docpanel = DockPanel()
        docpanel.Children.Add(menu)
        docpanel.Children.Add(toolbar)
        docpanel.Children.Add(statusbar)
        docpanel.Children.Add(self.listview)
        # self
        self.Content = docpanel
        self.Width = 500
        self.Height = 300
        self.Title = "SeeMe for Windows v4"
        # event
        self.KeyDown += self.on_keydown

    def on_save(self, sender, e):
        """
            none
        """
        pass

    def on_quit(self, sender, e):
        """
            exit
        """
        self.Close()

    def on_keydown(self, sender, e):
        """
            e as System.Windows.Input.KeyEventArgs
        """
        if Keyboard.Modifiers == ModifierKeys.Control:
            if e.Key == Key.O:
                self.on_save(self, e)
            if e.Key == Key.Q:
                self.on_quit(self, e)

########################################################################
#
#                               Welcome
#
########################################################################

class WelcomeDlg(Window):
    """
        SeeMe Welcome class
    """
    def __init__(self, sset, text):
        names = ["Default search.ini", "Custome search.ini", "operaprefs.ini", "lng File"]
        self.entrys = []
        sp = StackPanel()
        # description
        description = TextBlock()
        description.Text = text
        sp.Children.Add(description)
        # Edit
        for i in range(4):
            dp = DockPanel()
            tb = TextBlock()
            tb.Text = names[i]
            tb.MinWidth = 130
            tx = TextBox()
            tx.AllowDrop = True
            tx.Drop += self.on_drop
            tx.PreviewDragOver += self.on_drag_over
            self.entrys.append(tx)
            dp.Children.Add(tb)
            dp.Children.Add(tx)
            sp.Children.Add(dp)
        buttons = DockPanel()
        buttons.LastChildFill = False
        ok = Button()
        ok.Content = "_Ok"
        ok.IsDefault = True
        ok.Width = 100
        ok.Height = 23
        ok.Click += self.on_ok
        DockPanel.SetDock(ok, Dock.Right)
        buttons.Children.Add(ok)
        cancel = Button()
        cancel.Content = "Cancel"
        cancel.IsCancel = True
        cancel.Width = 100
        cancel.Height = 23
        cancel.Click += self.on_cancel
        DockPanel.SetDock(cancel, Dock.Right)
        buttons.Children.Add(cancel)
        sp.Children.Add(buttons)
        self.Content = sp
        # Value Set
        if sset.default_path == "":
            self.entrys[0].Text = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + "\\Opera 10 Beta\\locale\\ja\\search.ini"
        else:
            self.entrys[0].Text = sset.default_path
        if sset.custome_path == "":
            self.entrys[1].Text = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\Opera\\Opera 10 Beta\\search.ini"
        else:
            self.entrys[1].Text = sset.custome_path
        if sset.prefs_path == "":
            self.entrys[2].Text = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\Opera\\Opera 10 Beta\\operaprefs.ini"
        else:
            self.entrys[2].Text = sset.prefs_path
        if sset.lang_path == "":
            self.entrys[3].Text = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + "\\Opera 10 Beta\\locale\\ja\\ja.lng"
        else:
            self.entrys[3].Text = sset.lang_path
        # self
        self.Title = "Seeme へようこそ"
        self.SizeToContent = SizeToContent.WidthAndHeight
        self.WindowStartupLocation = WindowStartupLocation.CenterScreen
        self.WindowStyle = WindowStyle.ThreeDBorderWindow

    def on_drag_over(self, sender, e):
        e.Handled = e.Data.GetData(DataFormats.FileDrop) != None

    def on_drop(self, sender, e):
        files = e.Data.GetData(DataFormats.FileDrop)
        sender.Text = str(files[0])

    def on_ok(self, sender, e):
        self.DialogResult = True
        self.Close()

    def on_cancel(self, sender, e):
        self.DialogResult = False
        self.Close()

########################################################################
#
#                               main
#
########################################################################

def main():
    inipath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\sasakima\\seeme\\setting4.ini";
    sset = SeeMeSetting()
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        sset.prefs_path = ini.read_str("Path", "Prefs1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.default_path2 = ini.read_str("Path", "Default2", "")
        sset.custome_path2 = ini.read_str("Path", "Custome2", "")
        sset.prefs_path2 = ini.read_str("Path", "Prefs2", "")
        sset.lang_path2 = ini.read_str("Path", "Lang2", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        MessageBox.Show("%s" % s)
        sys.exit()
    if sset.version < 2:
        # New
        if sset.version == 0:
            description = welcome_description
        else:
            description = change_description
        # file version 1 to 2
        sset.default_path = ""
        sset.lang_path    = ""
        # end
        dlg = WelcomeDlg(sset, description)
        # dlg.Show() で表示すると即終了
        if dlg.ShowDialog():#.Value: は不要
            sset.default_path = dlg.entrys[0].Text
            sset.custome_path = dlg.entrys[1].Text
            sset.prefs_path =   dlg.entrys[2].Text
            sset.lang_path =    dlg.entrys[3].Text
            a = Application()
            a.Run(SeeMe(sset))
        else:
            MessageBox.Show("bye !")
            sys.exit()

if __name__ == "__main__":
    main()